<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomSeatPrice ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCustomSeatPrice
 * @subpackage Arrays
 */
class ArrayOfCustomSeatPrice extends AbstractStructArrayBase
{
    /**
     * The CustomSeatPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \patest\StructType\CustomSeatPrice[]
     */
    public $CustomSeatPrice;
    /**
     * Constructor method for ArrayOfCustomSeatPrice
     * @uses ArrayOfCustomSeatPrice::setCustomSeatPrice()
     * @param \patest\StructType\CustomSeatPrice[] $customSeatPrice
     */
    public function __construct(array $customSeatPrice = array())
    {
        $this
            ->setCustomSeatPrice($customSeatPrice);
    }
    /**
     * Get CustomSeatPrice value
     * @return \patest\StructType\CustomSeatPrice[]|null
     */
    public function getCustomSeatPrice()
    {
        return $this->CustomSeatPrice;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSeatPrice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSeatPrice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSeatPriceForArrayConstraintsFromSetCustomSeatPrice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomSeatPriceCustomSeatPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomSeatPriceCustomSeatPriceItem instanceof \patest\StructType\CustomSeatPrice) {
                $invalidValues[] = is_object($arrayOfCustomSeatPriceCustomSeatPriceItem) ? get_class($arrayOfCustomSeatPriceCustomSeatPriceItem) : sprintf('%s(%s)', gettype($arrayOfCustomSeatPriceCustomSeatPriceItem), var_export($arrayOfCustomSeatPriceCustomSeatPriceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomSeatPrice property can only contain items of type \patest\StructType\CustomSeatPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomSeatPrice value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\CustomSeatPrice[] $customSeatPrice
     * @return \patest\ArrayType\ArrayOfCustomSeatPrice
     */
    public function setCustomSeatPrice(array $customSeatPrice = array())
    {
        // validation for constraint: array
        if ('' !== ($customSeatPriceArrayErrorMessage = self::validateCustomSeatPriceForArrayConstraintsFromSetCustomSeatPrice($customSeatPrice))) {
            throw new \InvalidArgumentException($customSeatPriceArrayErrorMessage, __LINE__);
        }
        $this->CustomSeatPrice = $customSeatPrice;
        return $this;
    }
    /**
     * Add item to CustomSeatPrice value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\CustomSeatPrice $item
     * @return \patest\ArrayType\ArrayOfCustomSeatPrice
     */
    public function addToCustomSeatPrice(\patest\StructType\CustomSeatPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\CustomSeatPrice) {
            throw new \InvalidArgumentException(sprintf('The CustomSeatPrice property can only contain items of type \patest\StructType\CustomSeatPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomSeatPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\CustomSeatPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\CustomSeatPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\CustomSeatPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\CustomSeatPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\CustomSeatPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomSeatPrice
     */
    public function getAttributeName()
    {
        return 'CustomSeatPrice';
    }
}
